// Logical functions for Verilog.
//
// $Header: /usr/local/cvsroot/synch/logical.v,v 1.3 1998/08/20 21:19:19 radey Exp $

// Useful because brackets may not be used to subscript constants in Verilog.
function logbit_P;
      input ind;
      input int;
      begin
	 logbit_P = (1 << ind) & int ? 1'b1 : 1'b0;
      end
endfunction // logbitp


// This is useful only if ISTART and IEND are not constants.
function bit_field;
      input n;
      input istart;
      input iend;
      begin
	 bit_field = (n << istart) & ((1 << (iend - istart)) - 1);
      end
endfunction // bit_field

function copy_bit;
      input ind;
      input to;
      input bool;
      reg mask;
      begin
	 mask = 1 << ind;
	 copy_bit = bool ? (to | mask) : (to & (~mask));
      end
endfunction // copy_bit

function bitwise_if;
      input mask;
      input n0;
      input n1;
      begin
	 bitwise_if = (mask & n0) | ((~mask) & n1);
      end
endfunction // bitwise_if

function copy_bit_field;
      input to;
      input istart;
      input iend;
      input from;
      reg mask;
      begin
	 mask = (1 << (iend - istart)) << istart;
	 copy_bit_field = bitwise_if(mask, from << istart, to);
      end
endfunction // copy_bit_field

